unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IniFiles, Menus, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    File1: TMenuItem;
    Open: TMenuItem;
    N3: TMenuItem;
    rec1: TMenuItem;
    rec2: TMenuItem;
    rec3: TMenuItem;
    rec4: TMenuItem;
    RecSeparator: TMenuItem;
    Exit: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure rec1Click(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure rec2Click(Sender: TObject);
    procedure rec3Click(Sender: TObject);
    procedure rec4Click(Sender: TObject);
    procedure ExitClick(Sender: TObject);
  private
    { Private declarations }
    Recentlist: TStringList;
    RecentChange: Boolean;
    procedure OpenRecent;
    procedure ManageRecent;
    procedure AppleRecent(const FileName: String);
    procedure SaveRecent;
    procedure OpenFile(const Filename: String);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
const
  MaxRecent: integer = 4;

implementation

{$R *.dfm}

{ TForm1 }

procedure TForm1.AppleRecent(const FileName: String);
begin
 RecentChange:= True; // ,    
 if RecentList.IndexOf(FileName)= -1 then //     , ...
 begin
  RecentList.Insert(0, FileName); //   
  if RecentList.Count > MaxRecent then //      
   RecentList.Delete(MaxRecent); //     
 end
 else // ...
  RecentList.Move(RecentList.IndexOf(FileName),0);
 ManageRecent; //    ManageRecent
end;

procedure TForm1.ManageRecent;
var
  MenuItem: TMenuItem;
  i: Integer;
begin
  i:= 0; //   i
  while (i < (Recentlist.Count)) and (i < MaxRecent) do //    rec
  begin
    MenuItem:= TMenuItem(FindComponent(concat('rec', IntToStr(i+1))));
    MenuItem.Visible:= True; //  
    MenuItem.Caption:= RecentList.Strings[i]; //      StringList
    Inc(i); //   i
  end;
RecSeparator.Visible:= rec1.Visible; //  ,  
end;

procedure TForm1.OpenRecent;
var
  FileIni: TIniFile;
  i: Integer;
  St: String;
begin
  RecentList:= TStringList.Create;  // StringList
  FileIni:= TIniFile.Create('MyFileIni.ini'); // INI-,   
  for i:= 1 to MaxRecent do //     ...
  begin
    St:= FileIni.ReadString(
        'Recent',Concat('rec',IntToStr(i)),'');
         //    
    RecentList.Add(St); //    
  end;
  while RecentList.IndexOf('') <> -1 do
    //   , 
    Recentlist.Delete(RecentList.IndexOf(''));
end;

procedure TForm1.OpenFile(const FileName: string);
begin
  Image1.Picture.LoadFromFile(FileName); //     TImage
  AppleRecent(FileName); //   AppleRecent   OpenDialog1.FileName
end;

procedure TForm1.SaveRecent;
var
  FileIni: TIniFile;
  i: Integer;
begin
  if RecentChange then //   , ...
  begin
    FileIni:= TIniFile.Create('MyFileIni.ini'); //  INI-,   
    i:= 0; //  i  0
    while (i < (Recentlist.Count)) and (i < MaxRecent) do //    "rec"
    begin
      FileIni.WriteString('Recent',concat('rec',IntToStr(i+1)),
      Recentlist.Strings[i]); //       
      Inc(i); //   i
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenRecent; //   OpenRecent
  ManageRecent; //   ManageRecent
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SaveRecent; //   SaveRecent
  Recentlist.Free; //  
end;

procedure TForm1.OpenClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    OpenFile(OpenDialog1.FileName);
end;

procedure TForm1.rec1Click(Sender: TObject);
begin
  OpenFile(rec1.Caption);
end;

procedure TForm1.rec2Click(Sender: TObject);
begin
  OpenFile(rec2.Caption);
end;

procedure TForm1.rec3Click(Sender: TObject);
begin
  OpenFile(rec3.Caption);
end;

procedure TForm1.rec4Click(Sender: TObject);
begin
  OpenFile(rec4.Caption);
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  Close;
end;

end.
